<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "data_source_type".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "DataTypes".
 *
 * Columns in table "data_source_type" available as properties of the model,
 * followed by relations of table "data_source_type" available as properties of the model.
 *
 * @property integer $id
 * @property string $name
 * @property string $description
 *
 * @property DataSource[] $dataSources
 */
abstract class BaseDataType extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'data_source_type';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'DataTypes|DataTypes', $n);
    }

    public static function representingColumn()
    {
        return 'name';
    }

    public function rules()
    {
        return array(
            array('id, name', 'required'),
            array('id', 'numerical', 'integerOnly'=>true),
            array('name, description', 'length', 'max'=>45),
            array('description', 'default', 'setOnEmpty' => true, 'value' => null),
            array('id, name, description', 'safe', 'on'=>'search'),
        );
    }

    public function relations()
    {
        return array(
            'dataSources' => array(self::HAS_MANY, 'DataSource', 'data_type_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'name' => Yii::t('app', 'Name'),
            'description' => Yii::t('app', 'Description'),
            'dataSources' => null,
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('name', $this->name, true);
        $criteria->compare('description', $this->description, true);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria, 'pagination' => array('pageSize' => 100)
        ));
    }

}
